'add.bas by df6nm 
'adds weighted ebnaut fft data file into sum.txt
'usage: 
'add file.txt [dB phase]


'$ lang: "qb"
deflng a-z

fname$="fftexport.txt"
cmd$ = ltrim$(rtrim$(command$))
cmd1$=cmd$
if instr(cmd$," ") > 0 then cmd1$ = left$(cmd$,instr(cmd$," ")-1)  
if len(cmd1$)>=1 then fname$=cmd1$ 

cmd2$=right$(cmd$,len(cmd$)-len(cmd1$))
if instr(cmd2$," ") > 0 then cmd2$ = right$(cmd2$,len(cmd2$)-instr(cmd2$," "))  
cmd2$=ltrim$(cmd2$)
dB!=val(cmd2$)
if instr(cmd2$," ") > 0 then cmd2$ = right$(cmd2$,len(cmd2$)-instr(cmd2$," "))  
cmd2$=ltrim$(cmd2$)
phase!=val(cmd2$)
? fname$;" ";dB!;" dB ";phase!;" deg"

wflag=0
if dB!<>0 or phase!<>0 then
 wflag=1
 ampl!=10^(dB!/20)
 phi!=phase!*atn(1)/45!
 wr!=ampl!*cos(phi!)
 wi!=ampl!*sin(phi!)
end if
open "sum.txt" for binary as 1
if lof(1)>20 then sumflag=1
close 1

open "sum.txt" for input as 1
open fname$ for input as 2
open "sum.tmp" for output as 3

if sumflag then INPUT #1, oldfiledate&, oldfiletime!, oldbw!, oldstartfreq!
INPUT #2, filedate&, filetime!, bw!, startfreq!
? #3,ltrim$(str$(filedate&));filetime!;bw!;startfreq!;

cnt=0
r1!=0:i1!=0
while not eof(2)
 if sumflag then
  INPUT #1, r1!, i1!
  p1!=p1!+r1!*r1!+i1!*i1!
 end if
 INPUT #2, r2!, i2!
 p2!=p2!+r2!*r2!+i2!*i2!
 cnt=cnt+1
 if wflag then
  r3!=r1!+r2!*wr!-i2!*wi!
  i3!=i1!+r2!*wi!+i2!*wr!
 else
  r3!=r1!+r2!
  i3!=i1!+i2!
 end if
 p3!=p3!+r3!*r3!+i3!*i3!
 ? #3," "+ltrim$(str$(r3!))+" "+ltrim$(str$(i3!));
wend
close 3
close 2
close 1
shell ("del sum.txt & ren sum.tmp sum.txt")
if cnt >0 then
 p1!=sqr(p1!/cnt)
 p2!=sqr(p2!/cnt)
 p3!=sqr(p3!/cnt)
 ? cnt;"bins ";p1!;p2!;p3!;" rms"
end if

end

